//Module History:
//  08/30/2005   J. Miller    Properly submit tasks_frame size after initial resize
var navFrameSize_ = null;
var tasksFrameSize_ = null;
var waFrameSize_ = null;
var submitted = false;

//setInitialFrameSizes - store initial frame dimensions, neded for IE workaround to limit frame size servlet calls
// -in: none
//-out: none, sets global frame size variables
function setInitialFrameSizes() {
  var userAgent = navigator.userAgent.toLowerCase();
  var isIE = ( userAgent.indexOf( "msie" ) != -1 ) && (!(( navigator.userAgent.indexOf("Opera") !=-1 ) && ( navigator.userAgent.indexOf("MSIE") !=-1)));

  //globals only used in IE
  if ( !isIE ) {
    return;
  }

  try {
    var frame  = window.top.hmcmainui.navigation_frame;
    if ( frame && frame.document && frame.document.body ) {
      navFrameSize_ = isIE ? frame.document.body.clientWidth : frame.innerWidth;
    }
  } catch (e) {
  }

  try {
    var frame = window.top.hmcmainui.workarea_frame.frames[0];
    if ( frame && frame.document && frame.document.body ) {
      waFrameSize_ = isIE ? frame.document.body.clientHeight : frame.innerHeight;
    }
  } catch (e) {
  }

  try {
    var frame = window.top.hmcmainui.workarea_frame.frames[1];
    if ( frame && frame.document && frame.document.body ) {
      tasksFrameSize_ = isIE ? frame.document.body.clientHeight : frame.innerHeight;
    }
  } catch (e) {
  }
}


//saveFrameDimensions - submit dimensions for known frames to server
// -in: e      - event which triggered this method
//      ieOnly - if true, only perform the action for IE Browser, otherwise 
//               perform the action for all browsers.  onResize events aren't 
//               thrown for our frames in IE due to the TaskController frame, so
//               IE on load/unload events are generated to trigger frame size events
//-out: none, frame size form submitted if needed
function saveFrameDimensions(e, ieOnly) {
  var userAgent = navigator.userAgent.toLowerCase();
  var isIE = ( userAgent.indexOf( "msie" ) != -1 ) && (!(( navigator.userAgent.indexOf("Opera") !=-1 ) && ( navigator.userAgent.indexOf("MSIE") !=-1)));

  if ( ieOnly && !isIE ) {
    return;
  }

  var navFrameSize = null;
  var tasksFrameSize = null;
  var waFrameSize = null;
  var submitMe = false;
  e = window.event;

  var formName = "frameSizeForm";
  var form = document.forms[formName];
  if ( form == null ) {
    form = document.createElement( "FORM" );
    with ( form ) {
      name   = formName;
      id     = formName;
//      action = "/hmc/frames";
      action = "/hmc/ui/bonsai/frames.do";
      method = "POST";
    }
  }

  //navigation frame
  try {
    var inputName = "navigation_frame";
    var frame  = window.top.hmcmainui.navigation_frame;
    var input  = document.getElementById( inputName );
   
    if ( frame && frame.document && frame.document.body && frame.document.body.clientWidth ) {
      navFrameSize = frame.document.body.clientWidth;
      if ( !input ) {
        input = document.createElement( "INPUT" );
        with ( input ) {
          type  = "hidden";
          id    = inputName;
          name  = inputName;
        }
        form.appendChild( input );
      }
      input.value = navFrameSize;
    } else if ( input ) {
      form.removeChild( input );
    }
  } catch (e) {
  }

  //*_workarea_frame
  try {
    var frame = window.top.hmcmainui.workarea_frame.frames[0];
    var inputName = "workarea_frame";
    var input  = document.getElementById( inputName );

    if ( frame && frame.document && frame.document.body && frame.document.body.clientHeight ) {
      waFrameSize = frame.document.body.clientHeight;
      if ( !input ) {
        input = document.createElement( "INPUT" );
        with ( input ) {
          type  = "hidden";
          id    = inputName;
          name  = inputName;
        }
        form.appendChild( input );
      }
      input.value = waFrameSize;
    } else if ( input ) {
      form.removeChild( input );
    }
  } catch (e) {
  }

  //tasks_frame
  try {
    var inputName = "tasks_frame";
    var frame = window.top.hmcmainui.workarea_frame.frames[1];
    var input  = document.getElementById( inputName );
    
    if ( frame && frame.document && frame.document.body && frame.document.body.clientHeight ) {
      tasksFrameSize = frame.document.body.clientHeight;
      if ( !input ) {
        input = document.createElement( "INPUT" );
        with ( input ) {
          type  = "hidden";
          id    = inputName;
          name  = inputName;
        }
        form.appendChild( input );
      }
      input.value = tasksFrameSize;
    } else if ( input ) {
      form.removeChild( input );
    }
  } catch (e) {
  }

  //document.appendChild( form );
  document.body.appendChild(form);
  if ( !isIE
    || navFrameSize_   != navFrameSize
    || waFrameSize_    != waFrameSize
    || tasksFrameSize_ != tasksFrameSize
     ) 
  {
    document.forms[formName].submit();

    //IE onbeforeunload timing issue fix
    if ( isIE ) {
      pause(250);
    }

    navFrameSize_   = navFrameSize;
    waFrameSize_    = waFrameSize;
    tasksFrameSize_ = tasksFrameSize;

    return true;
  }
}

//pause - wait for given number of milliseconds, not the most effective pause
//        routine since it eats CPU cycles while waiting
// -in: ms - number of milliseconds to wait
//-out: none
function pause(ms) {
//alert("pausing for " + ms + "ms");
  var date = new Date();
  var stopTime = date.getTime() + ms;
  while(true) {
    date = new Date();
    if ( date.getTime() > stopTime ) {
      return;
    }
  }
}
