/*  
 * (c)  Copyright  IBM Corp.  1999, 2003  All Rights Reserved
 *
 *
 * US Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp
 *
 * Notes:
 * js file used to prevent drag-and-drop actions within a page 
 *
 * Module History:
 *     11/10/2005   JMiller        Initial Release
 */

//IE
document.ondragstart = function(e) {
  return false;
}

//Mozilla
document.onmousedown = function(e) {
  if ( e && e.preventDefault ) {
    var target = e.target;
    if ( target.nodeName.toUpperCase() == "IMG" ) {
      e.preventDefault();
      return false;
    }
    while (target) {
      if (target.nodeName.toUpperCase() == "A") {
        e.preventDefault();
        return false;
      }
      target = target.parentNode;
    }
  }
} 
